// TPRv2 für LeoBot (2013-11-27, nur für privaten Gebrauch)  
// RGB funktioniert noch nicht zufriedenstellend
// es können noch viele Fehler enthalten sein!
// in Zeile 79 kann die Kommentierung einmal entfernt werden, um Beispiel1 ins EEPROM zu übertragen
// wird die Kommentierung nicht wieder angebracht, kann NICHT manuell programmiert werden!
// 
//################################################################################## 
#include <EEPROM.h>
#include <avr/eeprom.h> 
#include <Servo.h>

const byte Motor_y = 0x00;
const byte Out_y = 0x10;
const byte Waitms = 0x20;
const byte Jr_y = 0x30;
const byte A_y = 0x40;
const byte B_y = 0x50;
const byte A_Port = 0x60;
const byte B_Port = 0x70;
const byte Ziel_A = 0x80;
const byte Ziel_B = 0x90;
const byte D_y = 0xA0;
const byte H_y = 0xB0;
const byte L_y = 0xC0;
const byte Jr_D = 0xD0;
const byte Jp_HL = 0xE0;
const byte Jr_Jp = 0xF0;

const byte In0 = 0;
const byte In1 = 1; 
const byte In2 = 2;
const byte In3 = 3;
const byte Out0 = 4; 
const byte Out1 = 5;
const byte Out2 = 6;
const byte Out3 = 7;
const byte Us1_E = 8;
const byte Pwm1 = 9;
const byte Pwm2 = 10;
const byte Pwm3 = 11;
const byte Us2_E = 12;
const byte Us_P = 13;
const byte Ad0 = 0; 
const byte Ad1 = 1; 
const byte Ad2 = 2; 
const byte Ad3 = 3; 
const byte Ad4 = 4; 
const byte Ad5 = 5; 
const byte DEBOUNCE = 100;

Servo servo1;
Servo servo2;
Servo servo3;

boolean prgMode;
byte a,b,d,h,l, State = 0, Dat = 0, Kom = 0;
word rot,grun,blau,tmpw,PC,Us;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void setup() {                
  pinMode(In0, INPUT);  digitalWrite(In0, HIGH);    //Taste links prgMode
  pinMode(In1, INPUT);  digitalWrite(In1, HIGH);
  pinMode(In0, INPUT);  digitalWrite(In0, HIGH);  //In-Port
  pinMode(In1, INPUT);  digitalWrite(In1, HIGH);
  pinMode(In2, INPUT);  digitalWrite(In2, HIGH);
  pinMode(In3, INPUT);  digitalWrite(In3, HIGH);  
  pinMode(Out0, OUTPUT);
  pinMode(Out1, OUTPUT);
  pinMode(Out2, OUTPUT);
  pinMode(Out3, OUTPUT);
  pinMode(Us1_E, INPUT); //digitalWrite(Us1_E, HIGH);
  pinMode(Pwm1, OUTPUT);
  pinMode(Pwm2, OUTPUT);
  pinMode(Pwm3, OUTPUT);
  pinMode(Us2_E, INPUT); //digitalWrite(Us2_E, HIGH);
  pinMode(Us_P, OUTPUT);
  digitalWrite(A4, HIGH);      //Pullup Ad4+5
  digitalWrite(A5, HIGH);
  servo1.detach();  servo2.detach();  servo3.detach();  PC = 0; a = 0;  b = 0;  d = 0; h=0; l=0;
//  doEEPROM();          //Beispiel1, nur einmal aktivieren!
  if (digitalRead(In1)==0) {prgMode=1;}
}
//################################################################################## MAIN 
void loop() {
  if (prgMode==1) {ProgMode();}
  else {
    byte value = EEPROM.read(PC);    byte Kom = (value & 0xF0);    byte Dat = (value & 0x0F); //Pullup
    PC++;    a=a&15; b=b&15; 
    servo1.attach(9);  servo2.attach(10);  servo3.attach(11);
    switch (Kom) {      
      case Motor_y:     doMotor(Dat);     break;  
      case Out_y:       doPort(Dat);      break;  
      case Waitms:      doDelay(Dat);     break;  
      case Jr_y:        doJumpBack(Dat);  break;  
      case A_y:         doSetA(Dat);      break;  
      case B_y:         doSetB(Dat);      break;  
      case A_Port:      doA_Port(Dat);    break;
      case B_Port:      doB_Port(Dat);    break;
      case Ziel_A:      doZiel_A(Dat);    break;
      case Ziel_B:      doZiel_B(Dat);    break;
      case D_y:         doD_y(Dat);       break;
      case H_y:         doH_y(Dat);       break;
      case L_y:         doL_y(Dat);       break;
      case Jr_D:        doJr_D(Dat);      break;
      case Jp_HL:       doJp_HL(Dat);     break;
      case Jr_Jp:       doJr_Jp(Dat);     break;
      default:      ;    }
  }
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=0
void doMotor(byte Dat) {
  switch (Dat) {
    case 0:  servo1.write(90);  servo2.write(90);  servo3.write(90);  break;
    case 1:  servo1.write(90);  break;
    case 2:  servo2.write(90);  break;
    case 3:  servo1.write(102);  break;
    case 4:  servo2.write(78);  break;
    case 5:  servo1.write(78);  break;
    case 6:  servo2.write(102);  break;
    case 7:  servo3.write(10);  break;
    case 8:  servo3.write(30);  break;
    case 9:  servo3.write(50);  break;
    case 10:  servo3.write(70);  break;
    case 11:  servo3.write(90);  break;
    case 12:  servo3.write(110);  break;
    case 13:  servo3.write(130);  break;
    case 14:  servo3.write(150);  break;
    case 15:  servo3.write(170);  break;
    default:  break;    }
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=1
void doPort(byte Dat) {
  digitalWrite(Out0,(Dat & 0x01)>0);
  digitalWrite(Out1,(Dat & 0x02)>0);
  digitalWrite(Out2,(Dat & 0x04)>0);
  digitalWrite(Out3,(Dat & 0x08)>0);
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=2
void doDelay(byte Dat) {
  switch (Dat) {
    case 0:     delay(1);    break;
    case 1:     delay(2);    break;
    case 2:     delay(4);    break;
    case 3:     delay(8);    break;
    case 4:     delay(16);    break;
    case 5:     delay(32);    break;
    case 6:     delay(64);    break;
    case 7:     delay(128);    break;
    case 8:     delay(256);    break;
    case 9:     delay(512);    break;
    case 10:     delay(1024);    break;
    case 11:     delay(2048);    break;
    case 12:     delay(4096);    break;
    case 13:     delay(8192);    break;
    case 14:     delay(16384);    break;
    case 15:     delay(32768);    break;
    default:  break;    }
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=3
void doJumpBack(byte Dat) {  PC = PC + Dat-1; if (Dat > 7) { PC = PC - 16;}
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=4
void doSetA(byte Dat) {  a = Dat;
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=5
void doSetB(byte Dat) {  b = Dat;
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=6
void doA_Port(byte Dat) {
  switch (Dat) {
  case 0:  tmpw = analogRead(Ad0);  a = tmpw / 64;  break;
  case 1:  tmpw = analogRead(Ad1);  a = tmpw / 64;  break;
  case 2:  tmpw = analogRead(Ad2);  a = tmpw / 64;  break;
  case 3:  tmpw = analogRead(Ad3);  a = tmpw / 64;  break;
  case 4:  tmpw = analogRead(Ad4);  a = tmpw / 64;  break;
  case 5:  tmpw = analogRead(Ad5);  a = tmpw / 64;  break;
  case 8:  a=digitalRead(In0)+digitalRead(In1)*2+digitalRead(In2)*4+digitalRead(In3)*8;  break;
  case 9:  a = digitalRead(Us1_E);  break;
  case 10:  a = digitalRead(Us2_E);  break;
  case 11:  digitalWrite(Us_P,HIGH); delayMicroseconds(10); digitalWrite(Us_P,LOW); while(digitalRead(Us1_E)==0){}; Us=0; while(digitalRead(Us1_E)==1){delayMicroseconds(59); Us++;}; if (Us>15){a=15;} else {a=Us;}   break;
  case 12:  digitalWrite(Us_P,HIGH); delayMicroseconds(10); digitalWrite(Us_P,LOW); while(digitalRead(Us2_E)==0){}; Us=0; while(digitalRead(Us2_E)==1){delayMicroseconds(59); Us++;}; if (Us>15){a=15;} else {a=Us;}   break;
  case 13:  rot=analogRead(Ad0)*1;  grun=analogRead(Ad1)*2;  blau=analogRead(Ad2)*2; tmpw=(rot+grun+blau)/2.2; 
            if (tmpw<rot) {a=1;} else {a=0;} if (tmpw<grun) {a=a+2;}  if (tmpw<blau) {a=a+4;} break;
  case 14:  tmpw = analogRead(Ad3); a=8274/tmpw-8; break;//do4Tasten(a);  break;
  case 15:  a = (a + b)/2;  break;
  default:  break;      }
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=7
void doB_Port(byte Dat) {
  switch (Dat) {
  case 0:  tmpw = analogRead(Ad0);  b = tmpw / 64;  break;
  case 1:  tmpw = analogRead(Ad1);  b = tmpw / 64;  break;
  case 2:  tmpw = analogRead(Ad2);  b = tmpw / 64;  break;
  case 3:  tmpw = analogRead(Ad3);  b = tmpw / 64;  break;
  case 4:  tmpw = analogRead(Ad4);  b = tmpw / 64;  break;
  case 5:  tmpw = analogRead(Ad5);  b = tmpw / 64;  break;
  case 8:  b=digitalRead(In0)+digitalRead(In1)*2+digitalRead(In2)*4+digitalRead(In3)*8;  break;
  case 9:  b = digitalRead(Us1_E);  break;
  case 10:  b = digitalRead(Us2_E);  break;
  case 11:  digitalWrite(Us_P,HIGH); delayMicroseconds(10); digitalWrite(Us_P,LOW); while(digitalRead(Us1_E)==0){}; Us=0; while(digitalRead(Us1_E)==1){delayMicroseconds(59); Us++;}; if (Us>15){b=15;} else {b=Us;}   break;
  case 12:  digitalWrite(Us_P,HIGH); delayMicroseconds(10); digitalWrite(Us_P,LOW); while(digitalRead(Us2_E)==0){}; Us=0; while(digitalRead(Us2_E)==1){delayMicroseconds(59); Us++;}; if (Us>15){b=15;} else {b=Us;}   break;
  case 13:  rot=analogRead(Ad0);  grun=analogRead(Ad1)*2;  blau=analogRead(Ad2)*2; tmpw=(rot+grun+blau)/2.2; 
            if (tmpw<rot) {b=1;} else {b=0;} if (tmpw<grun) {b=b+2;}  if (tmpw<blau) {b=b+4;} break;
  case 14:  tmpw = analogRead(Ad3); b=8274/tmpw-8; break;//do4Tasten(b);  break;
  case 15:  b = random(15);  break;
  default:  break;      }
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=8
void doZiel_A(byte Dat) {
  switch (Dat) {
  case 0:  servo1.write(  6+a*12); break;
  case 1:  servo2.write(174-a*12); break;
  case 2:  servo3.write(  6+a*12); break;
  case 3:  a = 15 - a;  break;
  case 4:  a = a + 1;  break;
  case 5:  a = a - 1;  break;
  case 6:  a = a & b;  break;
  case 7:  a = a | b;  break;
  case 8:  doPort(a);  break;
  case 9:  digitalWrite(Us_P,a); break;
  case 12:     b = a;    break;
  case 13:     d = a;    break;
  case 14:     h = a;    break;
  case 15:     l = a;    break;
  default:  break;      }
}//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=9
void doZiel_B(byte Dat) {
  switch (Dat) {
  case 0:  servo1.write(  6+b*12); break;
  case 1:  servo2.write(174-b*12); break;
  case 2:  servo3.write(  6+b*12); break;
  case 3:  b = 15 - b;  break;
  case 4:  b = b + 1;  break;
  case 5:  b = b - 1;  break;
  case 6:  b = a + b;  break;
  case 7:  b = a - b;  break;
  case 8:  doPort(b);  break;
  case 9:  digitalWrite(Us_P,b); break;
  case 12:     a = b;    break;
  case 13:     d = b;    break;
  case 14:     h = b;    break;
  case 15:     l = b;    break;
  default:  break;  }
}//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=A
void doD_y(byte Dat) {  d = Dat;
}//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=B
void doH_y(byte Dat) {  h = Dat;
}//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=C
void doL_y(byte Dat) {  l = Dat;
}//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=D
void doJr_D(byte Dat) {if (a==Dat) {PC=PC+d-1; if (d>7) {PC=PC-16;} }
}//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=E
void doJp_HL(byte Dat) {if (a==Dat) {PC=h*16+l;  }
}//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ X=F
void doJr_Jp(byte Dat) {
  switch (Dat) {
  case 0:                PC = PC + d-1;     if (d>7) {PC=PC-16;} break;
  case 1:  if (a == b)  {PC = PC + d-1;  }  if (d>7) {PC=PC-16;} break;
  case 2:  if (a != b)  {PC = PC + d-1;  }  if (d>7) {PC=PC-16;} break;
  case 3:  if (a < b)  {PC = PC + d-1;  }  if (d>7) {PC=PC-16;} break;
  case 4:  if (a > b)  {PC = PC + d-1;  }  if (d>7) {PC=PC-16;} break;
  case 5:  if (a <= b)  {PC = PC + d-1;  }  if (d>7) {PC=PC-16;} break;
  case 6:  if (a >= b)  {PC = PC + d-1;  }  if (d>7) {PC=PC-16;} break;

  case 8:                PC = h*16 + l;     break;
  case 9:  if (a == b)  {PC = h*16 + l;  }  break;
  case 10:  if (a != b)  {PC = h*16 + l;  }  break;
  case 11:  if (a < b)  {PC = h*16 + l;  }  break;
  case 12:  if (a > b)  {PC = h*16 + l;  }  break;
  case 13:  if (a <= b)  {PC = h*16 + l;  }  break;
  case 14:  if (a >= b)  {PC = h*16 + l;  }  break;
  case 15:                PC = 0       ;     break;
  default:  break;    
  }
}
//################################################################################## ProgMode
void ProgMode() {
  do {} while (digitalRead(In1)==0); delay(99); PC=0;                               //warte bis In1 losgelassen
  do {
    State = 1; doPort(PC); delay(600);                                              //Adr. anzeigen
    byte Eebyte = EEPROM.read(PC);  Dat = Eebyte & 15;  Kom = Eebyte >> 4;          //Kom+Dat holen
    do {
      if (State<3) {doPort(Kom); digitalWrite(Us_P,HIGH);} 
        else {doPort(Dat); digitalWrite(Us_P,LOW);}                                 //Kom oder Dat anzeigen
      do {} while (digitalRead(In0)==digitalRead(In1)); delay(99);                  //warte wenn ? losgelassen
      if (digitalRead(In0)==0) {                                                    //STEP
        if (State==5) {Dat++; Dat=Dat&15; }                                         //Dat ändern
        if (State==3) {State=5; Dat=15; }
        if (State==2) {Kom++; Kom=Kom&15; }                                         //Kom ändern
        if (State==1) {State=2; Kom=15; }
        do {} while(digitalRead(In0)==0); delay(99);                                //warte bis STEP losgelassen
      }
      if (digitalRead(In1)==0) {                                                    //NEXT
        if (State < 3) {State = 3;}                                                 // nach Dat wechseln
          else {Dat=Dat&15; Eebyte=Kom*16; Eebyte=Eebyte+Dat; EEPROM.write(PC,Eebyte); PC++; State=0; }
        do {} while (digitalRead(In1)==0); delay(99);                               //warte bis NEXT losgelassen
      }
    } while (State |= 0);
  } while(prgMode);
}//################################################################################## Beispiel1
void doEEPROM() {  
  EEPROM.write(0x00,0x68); EEPROM.write(0x01,0x88); EEPROM.write(0x02,0x83); EEPROM.write(0x03,0x8E); 
  EEPROM.write(0x04,0xC0); EEPROM.write(0x05,0xF8); EEPROM.write(0x06,0xFF); EEPROM.write(0x07,0xFF); 
  EEPROM.write(0x08,0xFF); EEPROM.write(0x09,0xFF); EEPROM.write(0x0A,0xFF); EEPROM.write(0x0B,0xFF);
  EEPROM.write(0x0C,0xFF); EEPROM.write(0x0D,0xFF); EEPROM.write(0x0E,0xFF); EEPROM.write(0x0F,0xFF);
  
  EEPROM.write(0x10,0x2A); EEPROM.write(0x11,0x03); EEPROM.write(0x12,0x04); EEPROM.write(0x13,0x68); 
  EEPROM.write(0x14,0xAE); EEPROM.write(0x15,0xDF); EEPROM.write(0x16,0x05); EEPROM.write(0x17,0x06); 
  EEPROM.write(0x18,0x2A); EEPROM.write(0x19,0xA3); EEPROM.write(0x1A,0xDE); EEPROM.write(0x1B,0x04);
  EEPROM.write(0x1C,0xF8); EEPROM.write(0x1D,0x03); EEPROM.write(0x1E,0xF8); EEPROM.write(0x1F,0xFF);
  
  EEPROM.write(0x20,0x28); EEPROM.write(0x21,0x00); EEPROM.write(0x22,0x64); EEPROM.write(0x23,0x75); 
  EEPROM.write(0x24,0xA3); EEPROM.write(0x25,0xF3); EEPROM.write(0x26,0x04); EEPROM.write(0x27,0xF8); 
  EEPROM.write(0x28,0x03); EEPROM.write(0x29,0xF8); 
}//ENDE-------------------------------------------------------------------------------------------------

